"use strict";

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _create = require("babel-runtime/core-js/object/create");

var _create2 = _interopRequireDefault(_create);

var _defaults2 = require("babel-runtime/helpers/defaults");

var _defaults3 = _interopRequireDefault(_defaults2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _setPrototypeOf = require("babel-runtime/core-js/object/set-prototype-of");

var _setPrototypeOf2 = _interopRequireDefault(_setPrototypeOf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __extends = undefined && undefined.__extends || function () {
    var _extendStatics = function extendStatics(d, b) {
        _extendStatics = _setPrototypeOf2.default || (0, _extends3.default)({}, []) instanceof Array && function (d, b) {
            (0, _defaults3.default)(d, b);
        } || function (d, b) {
            for (var p in b) {
                if (b.hasOwnProperty(p)) d[p] = b[p];
            }
        };
        return _extendStatics(d, b);
    };
    return function (d, b) {
        _extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? (0, _create2.default)(b) : (__.prototype = b.prototype, new __());
    };
}();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var progress_1 = require("./progress");
// import * as AppHelper from "pps-commonfunction";
var lodash_omit_js_1 = require("./lodash.omit.js");
var axios_1 = require("axios");
var language_js_1 = require("./config/language.js");
var qs = function qs(obj) {
    var arr = (0, _keys2.default)(obj) || [];
    return arr.map(function (x) {
        return x + "=" + encodeURIComponent(obj[x]);
    }).join('&');
};
function getQueryObject(url) {
    if (!url) {
        url = location.hash;
    }
    // firefox获取location.hash会触发自动decode的bug，此处做判断兼容
    if (navigator.userAgent.toLowerCase().indexOf("firefox") > 0) {
        url = decodeURIComponent(url);
    }
    var hash = url.replace(/^(.*)\?(.*)$/, '$2').split('&');
    var obj = {};
    hash.map(function (item) {
        var attrs = item.split('=');
        obj[attrs[0]] = attrs[1];
    });
    return lodash_omit_js_1.default(obj, '_k');
}
function addParamsToUrl(url) {
    var urlParam = getQueryObject(url);
    if (urlParam._pt && urlParam._ptid) {
        url = url + '&_pt=' + urlParam._pt + '&_ptid=' + urlParam._ptid;
    }
    ;
    if (urlParam.shadow_context) {
        var d = url.indexOf('?') > 0 ? '&' : '?';
        url = url + d + 'shadow_context=' + urlParam.shadow_context;
    }
    ;
    return url;
}
var BSGlobal = window.BSGlobal || { I18NInfo: { I18NUserLang: 'zh_CN' } };
// class Cache {
//     data:any;
//     put(key:any, value:any, lifetime:any) {
//         const cache = {value};
//         this.data[key] = cache;
//     }
//     hit(key:any, lifetime:any) {
//         const cache = this.data[key];
//         if(cache) {
//             cache.expire = Date.now() + lifetime; 
//             if(!cache.timer)this.checkLater(key);
//         }
//     }
//     check = (key:any) => {
//         const cache = this.data[key];
//         if(cache) {
//             if(cache.expire < Date.now()){
//                 delete this.data[key];
//             } else {
//                 this.checkLater();
//             }
//         }
//     }
//     checkLater(key?:any) {
//         const cache = this.data[key];
//         if(cache) {
//             cache.timer = setTimeout(this.check, cache.expire-Date.now(), key);
//         }
//     }
// }
var Index = /** @class */function (_super) {
    __extends(Index, _super);
    function Index(props) {
        var _this = _super.call(this, props) || this;
        _this.timer = null;
        _this.state = {
            percent: 0,
            isShow: false,
            message: '',
            errorCount: 0,
            hasPercent: true
        };
        _this.openTimer = function (url, data, type) {
            var next = function next() {
                clearTimeout(_this.timer);
                _this.timer = setTimeout(function () {
                    _this.getProcess(url, data, type);
                    next();
                }, 1000000);
            };
            next();
        };
        _this.getProcess = function (url, data, type) {
            var isProgress = sessionStorage.getItem('_progress');
            clearTimeout(_this.timer);
            _this.source.cancel();
            if (parseInt(isProgress) !== 100 || !isProgress) {
                _this.initProcess(url, data, type, 2000);
            } else {
                _this.initProcess(url, data, type, 5000);
            }
        };
        _this.initProcess = function (url, data, type, time) {
            axios_1.default({
                method: 'POST',
                url: addParamsToUrl(url),
                //url: 'http://10.129.7.191:7300/mock/5d8863f3ed1a5d0020465426/example/demo1',
                headers: {
                    "Content-Type": "application/x-www-form-urlencoded"
                },
                cancelToken: _this.source.cancelToken,
                withCredentials: true,
                data: data
            }).then(function (res) {
                if (res.data.message) {
                    var message = JSON.parse(res.data.message);
                    // 当前进度
                    var percent = parseInt(message.Process);
                    // percent = null;
                    // 是否刷新页面
                    var isRefresh = message.IsRefresh;
                    var hasPercent = _this.state.hasPercent;
                    if (percent) {
                        percent = percent > 100 ? 100 : percent;
                    } else {
                        if (_this.percent && _this.percent < 80) {
                            _this.percent = _this.percent + 20;
                        } else if (!_this.percent) {
                            _this.percent = 20;
                        }
                        percent = _this.percent;
                        hasPercent = false;
                    }
                    sessionStorage.setItem('_progress', percent.toString());
                    var msg = message.Message ? message.Message : '';
                    var isShow = message.IsShow;
                    var errorCount = message.ErrorCount ? message.ErrorCount : 0;
                    if (errorCount > 0) {
                        percent = 100;
                    }
                    if (type && type == 'reload' && (percent == 100 && isRefresh || percent == -1 && isShow === false && _this.state.isShow)) {
                        var hashValue = location.hash && location.hash.split('?');
                        var random = Math.random();
                        var hrefValue = hashValue[0] + '?r=' + random + '&' + hashValue[1];
                        window.location.href = hrefValue;
                    }
                    _this.setState({
                        percent: percent,
                        isShow: isShow,
                        errorCount: errorCount,
                        hasPercent: hasPercent,
                        message: msg
                    }, function () {
                        clearTimeout(_this.timer);
                        _this.source.cancel();
                        _this.timer = setTimeout(function () {
                            _this.getProcess(url, data, type);
                        }, time);
                    });
                }
            }).catch(function (e) {
                clearTimeout(_this.timer);
                _this.source.cancel();
                _this.timer = setTimeout(function () {
                    _this.getProcess(url, data, type);
                }, time);
            });
        };
        _this.doSearch = function () {
            var _a = _this.props,
                cmp_id = _a.cmp_id,
                biz_data = _a.biz_data,
                actions = _a.actions,
                cmp_data = _a.cmp_data,
                expandRegion = _a.expandRegion;
            var _metaObjectName = cmp_data.metaObjectName;
            var newViewStr = _metaObjectName + "." + expandRegion.state;
            if (expandRegion && expandRegion.num == 1) {
                _this.props.containerContext.actions.common_set_biz_data(cmp_id, newViewStr, { text: "计算失败", name: newViewStr, value: "3" });
            }
        };
        // 初始化多语言配置
        var lan = 'zh_CN';
        _this.lanObj = {};
        if (BSGlobal.I18NInfo && BSGlobal.I18NInfo.I18NUserLang) {
            // 初始化语言配置
            lan = BSGlobal.I18NInfo.I18NUserLang;
        }
        for (var i in language_js_1.default) {
            _this.lanObj[i] = language_js_1.default[i][lan];
        }
        return _this;
    }
    Index.prototype.componentDidMount = function () {
        var expandRegion = this.props.expandRegion,
            url = expandRegion && expandRegion.url,
            data = expandRegion && expandRegion._body,
            type = expandRegion && expandRegion.type,
            param = expandRegion && expandRegion.param || {};
        this.percent = null;
        if (data && qs(param)) {
            data = data + "&" + qs(param);
        }
        this.CancelToken = axios_1.default.CancelToken;
        this.source = this.CancelToken.source();
        this.getProcess(url, data, type);
        // this.openTimer(url, data, type);
    };
    Index.prototype.render = function () {
        var _a = this.state,
            isShow = _a.isShow,
            message = _a.message,
            percent = _a.percent,
            errorCount = _a.errorCount,
            hasPercent = _a.hasPercent;
        return React.createElement("div", null, isShow ? React.createElement(progress_1.default, { lanObj: this.lanObj, percent: percent, message: message, errorCount: errorCount, doSearch: this.doSearch, hasPercent: hasPercent }) : null);
    };
    return Index;
}(React.Component);
exports.default = Index;