"use strict";

var _getOwnPropertySymbols = require("babel-runtime/core-js/object/get-own-property-symbols");

var _getOwnPropertySymbols2 = _interopRequireDefault(_getOwnPropertySymbols);

var _create = require("babel-runtime/core-js/object/create");

var _create2 = _interopRequireDefault(_create);

var _defaults2 = require("babel-runtime/helpers/defaults");

var _defaults3 = _interopRequireDefault(_defaults2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _setPrototypeOf = require("babel-runtime/core-js/object/set-prototype-of");

var _setPrototypeOf2 = _interopRequireDefault(_setPrototypeOf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __extends = undefined && undefined.__extends || function () {
    var _extendStatics = function extendStatics(d, b) {
        _extendStatics = _setPrototypeOf2.default || (0, _extends3.default)({}, []) instanceof Array && function (d, b) {
            (0, _defaults3.default)(d, b);
        } || function (d, b) {
            for (var p in b) {
                if (b.hasOwnProperty(p)) d[p] = b[p];
            }
        };
        return _extendStatics(d, b);
    };
    return function (d, b) {
        _extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? (0, _create2.default)(b) : (__.prototype = b.prototype, new __());
    };
}();
var __rest = undefined && undefined.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof _getOwnPropertySymbols2.default === "function") for (var i = 0, p = (0, _getOwnPropertySymbols2.default)(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var rc_progress_1 = require("rc-progress");
var classnames_1 = require("classnames");
require("./index.css");
// 预设进度条颜色
var statusColorMap = {
    start: '#ff5c5c',
    middle: '#ff8d0a',
    active: '#3d97ff',
    success: '#3d97ff',
    exception: '#ff5c5c' //异常
};
var statusInfoMap = {
    'start|middle|active': '计算中，请稍后…',
    'success': '计算已完成！',
    'exception': '计算出错！'
};
// 进度条进度处理函数
var validProgress = function validProgress(progress) {
    if (!progress || progress < 0) {
        return 0;
    } else if (progress > 100) {
        return 100;
    }
    return progress;
};
var Progress = /** @class */function (_super) {
    __extends(Progress, _super);
    function Progress() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.doSearch = function () {
            if (_this.props.doSearch) {
                _this.props.doSearch();
            }
        };
        return _this;
    }
    Progress.prototype.renderProcessInfo = function (prefixCls, progressStatus) {};
    Progress.prototype.renderProcessText = function () {};
    Progress.prototype.render = function () {
        var _a;
        var _b = this.props,
            prefixCls = _b.prefixCls,
            className = _b.className,
            _c = _b.percent,
            percent = _c === void 0 ? 90 : _c,
            status = _b.status,
            trailColor = _b.trailColor,
            size = _b.size,
            successPercent = _b.successPercent,
            _d = _b.message,
            message = _d === void 0 ? '' : _d,
            _e = _b.errorCount,
            errorCount = _e === void 0 ? 0 : _e,
            type = _b.type,
            strokeWidth = _b.strokeWidth,
            width = _b.width,
            showInfo = _b.showInfo,
            _f = _b.gapDegree,
            gapDegree = _f === void 0 ? 0 : _f,
            gapPosition = _b.gapPosition,
            strokeColor = _b.strokeColor,
            _g = _b.strokeLinecap,
            strokeLinecap = _g === void 0 ? 'round' : _g,
            hasPercent = _b.hasPercent,
            restProps = __rest(_b, ["prefixCls", "className", "percent", "status", "trailColor", "size", "successPercent", "message", "errorCount", "type", "strokeWidth", "width", "showInfo", "gapDegree", "gapPosition", "strokeColor", "strokeLinecap", "hasPercent"]);
        var _h = this.props.lanObj,
            web_calculation_completed = _h.web_calculation_completed,
            web_please_wait_calculating = _h.web_please_wait_calculating,
            web_ah_calculation_error = _h.web_ah_calculation_error,
            web_error_bars = _h.web_error_bars,
            web_click_to_view = _h.web_click_to_view;
        var progressInfo, progressMessage, progressStatusText, errorText;
        var progressStatus = 'start';
        progressStatusText = React.createElement("div", { className: prefixCls + "-show-text" }, web_please_wait_calculating);
        if (percent >= 50 && percent < 80) {
            progressStatus = 'middle';
        } else if (percent < 100 && !message) {
            progressStatus = 'active';
        } else if (percent == 100) {
            progressStatus = 'success';
            progressStatusText = React.createElement("div", { className: prefixCls + "-show-text" }, web_calculation_completed);
        }
        var circleWidth = strokeWidth || 6;
        var gapPos = gapPosition || type === 'dashboard' && 'bottom' || 'top';
        if (showInfo) {
            progressInfo = React.createElement("span", { className: prefixCls + "-text" }, validProgress(percent) + "%");
        }
        // 判断是否有提示语  提示语与计算状态显示不能共存
        if (message) {
            progressMessage = React.createElement("div", { className: prefixCls + "-status-message" }, message);
            progressStatusText = null;
        }
        if (errorCount > 0 && (percent == 100 && hasPercent || !hasPercent)) {
            progressStatus = 'exception';
            progressInfo = React.createElement("span", { className: prefixCls + "-text-error" });
            progressStatusText = React.createElement("div", { className: prefixCls + "-show-text" }, web_ah_calculation_error);
            errorText = React.createElement("div", { className: prefixCls + "-show-error" }, errorCount, web_error_bars, "\uFF0C", React.createElement("span", { className: 'clickTolook', onClick: this.doSearch }, web_click_to_view));
        } else if (percent == 100) {
            progressInfo = React.createElement("span", { className: prefixCls + "-text-success" });
        }
        var classString = classnames_1.default(prefixCls, (_a = {}, _a[prefixCls + "-" + (type === 'dashboard' && 'circle' || type)] = true, _a[prefixCls + "-status-" + progressStatus] = true, _a[prefixCls + "-show-info"] = showInfo, _a[prefixCls + "-show-message"] = message, _a[prefixCls + "-" + size] = size, _a), className);
        return React.createElement("div", { className: classString }, React.createElement("div", { className: "pps-progress-inner", style: { height: '120px', width: '120px' } }, React.createElement(rc_progress_1.Circle, { prefixCls: prefixCls, percent: validProgress(percent), strokeWidth: circleWidth, trailWidth: circleWidth, strokeColor: statusColorMap[progressStatus], strokeLinecap: strokeLinecap, trailColor: trailColor, gapDegree: gapDegree, gapPosition: gapPos }), progressInfo), progressStatusText, progressMessage, errorText);
    };
    Progress.defaultProps = {
        circle: 'circle',
        percent: 0,
        showInfo: true,
        trailColor: '#eaedf1',
        prefixCls: 'pps-progress',
        size: 'default'
    };
    return Progress;
}(React.Component);
exports.default = Progress;